<Manage::PageColSheet
  @options={{this.options}}
  @type={{this._row.columnValue.editorType}}
  @show={{if this.selectedCustomField true}}
  @title={{this.selectedCustomField}}
  @value={{this._row.cellValue}}
  @onChange={{this.changeCustomValue}}
/>

<div class='sheet-frame' {{did-insert this.fixInterface}}>
  <EmberTable as |t|>
    <t.head @columns={{this.columns}} as |h|>
      <h.row as |r|>
        <r.cell as |column columnMeta|>
          <div
            class='table-head'
            {{on
              'click'
              (fn this.onUpdateSorts column.valuePath (not this.sortOrder))
            }}
          >
            {{column.name}}

            {{#if (eq column.name this.sortField)}}
              {{#if this.sortOrder}}
                <FaIcon @icon='sort-up' />
              {{else}}
                <FaIcon @icon='sort-down' />
              {{/if}}
            {{/if}}
          </div>

          <EmberTh::ResizeHandle @columnMeta={{columnMeta}} />
        </r.cell>
      </h.row>
    </t.head>

    <t.body
      @firstVisibleChanged={{this.firstVisibleChanged}}
      @lastVisibleChanged={{this.lastVisibleChanged}}
      @rows={{@records}}
      as |b|
    >
      <b.row as |r|>
        <r.cell
          {{on 'click' (fn this.selectCell r)}}
          {{on 'dblclick' (fn this.selectCustomCell r)}}
          class='value-{{r.columnValue.key}}
            {{if r.cellMeta.selected "is-selected"}}'
          as |value column row cellMeta|
        >
          <div
            tabindex='0'
            class='td-container
              {{r.columnValue.typeClass}}
              {{if cellMeta.selected "is-selected"}}'
            contenteditable={{if
              (and
                (eq r.columnValue.typeClass 'editor-inline') cellMeta.selected
              )
              'true'
            }}
          >
            {{#if r.columnValue.type}}
              <View::Slot
                @preview={{true}}
                @value={{value}}
                @type={{r.columnValue.type}}
                @options={{r.columnValue.options}}
              />
            {{else}}
              {{value}}
            {{/if}}
          </div>
        </r.cell>
      </b.row>
    </t.body>
  </EmberTable>
</div>